ALTER table Product ADD COLUMN labelOrStudioOrNetworkOrDeveloperOrPublisher TEXT;
ALTER table Product ADD COLUMN companyName TEXT;
ALTER table Product ADD COLUMN imprint TEXT;
ALTER table Product ADD COLUMN isrcOrIsbn TEXT;

DROP TABLE CalculatedDayData;

DROP TABLE ReportLine;

CREATE TABLE ReportLine (primaryKey INTEGER PRIMARY KEY AUTOINCREMENT, countryIdentifier INTEGER, customerCurrencyIdentifier INTEGER, royaltyCurrencyIdentifier INTEGER, saleTypeIdentifier INTEGER, productTypeIdentifier INTEGER, units REAL, customerPrice REAL, royaltyPrice REAL, revenueInUSD REAL, reportId INTEGER, productId INTEGER, promoCode TEXT);

DROP TABLE CurrencyExchangeRate;

CREATE TABLE CurrencyExchangeRate (primaryKey INTEGER PRIMARY KEY AUTOINCREMENT, currencyIdentifier INTEGER, currencyCode TEXT, dateTimestamp INTEGER, rateToUSD REAL, needsRedownload INTEGER, needsRecalculation INTEGER, UNIQUE(dateTimestamp, currencyIdentifier) ON CONFLICT REPLACE);

CREATE INDEX CurrencyExchangeRateDateAndIdentifierIndex ON CurrencyExchangeRate(dateTimestamp, currencyIdentifier);

ALTER TABLE Country ADD COLUMN countryIdentifier INTEGER;

UPDATE Country SET countryIdentifier = '6' WHERE countryCode = 'AI'
UPDATE Country SET countryIdentifier = '8' WHERE countryCode = 'AG'
UPDATE Country SET countryIdentifier = '9' WHERE countryCode = 'AR'
UPDATE Country SET countryIdentifier = '15' WHERE countryCode = 'BS'
UPDATE Country SET countryIdentifier = '18' WHERE countryCode = 'BB'
UPDATE Country SET countryIdentifier = '21' WHERE countryCode = 'BZ'
UPDATE Country SET countryIdentifier = '23' WHERE countryCode = 'BM'
UPDATE Country SET countryIdentifier = '25' WHERE countryCode = 'BO'
UPDATE Country SET countryIdentifier = '29' WHERE countryCode = 'BR'
UPDATE Country SET countryIdentifier = '31' WHERE countryCode = 'VG'
UPDATE Country SET countryIdentifier = '41' WHERE countryCode = 'KY'
UPDATE Country SET countryIdentifier = '44' WHERE countryCode = 'CL'
UPDATE Country SET countryIdentifier = '48' WHERE countryCode = 'CO'
UPDATE Country SET countryIdentifier = '52' WHERE countryCode = 'CR'
UPDATE Country SET countryIdentifier = '59' WHERE countryCode = 'DM'
UPDATE Country SET countryIdentifier = '60' WHERE countryCode = 'DO'
UPDATE Country SET countryIdentifier = '62' WHERE countryCode = 'EC'
UPDATE Country SET countryIdentifier = '64' WHERE countryCode = 'SV'
UPDATE Country SET countryIdentifier = '88' WHERE countryCode = 'GD'
UPDATE Country SET countryIdentifier = '91' WHERE countryCode = 'GT'
UPDATE Country SET countryIdentifier = '94' WHERE countryCode = 'GY'
UPDATE Country SET countryIdentifier = '97' WHERE countryCode = 'HN'
UPDATE Country SET countryIdentifier = '109' WHERE countryCode = 'JM'
UPDATE Country SET countryIdentifier = '145' WHERE countryCode = 'MS'
UPDATE Country SET countryIdentifier = '157' WHERE countryCode = 'NI'
UPDATE Country SET countryIdentifier = '168' WHERE countryCode = 'PA'
UPDATE Country SET countryIdentifier = '170' WHERE countryCode = 'PY'
UPDATE Country SET countryIdentifier = '171' WHERE countryCode = 'PE'
UPDATE Country SET countryIdentifier = '186' WHERE countryCode = 'KN'
UPDATE Country SET countryIdentifier = '187' WHERE countryCode = 'LC'
UPDATE Country SET countryIdentifier = '189' WHERE countryCode = 'VC'
UPDATE Country SET countryIdentifier = '206' WHERE countryCode = 'SR'
UPDATE Country SET countryIdentifier = '219' WHERE countryCode = 'TT'
UPDATE Country SET countryIdentifier = '223' WHERE countryCode = 'TC'
UPDATE Country SET countryIdentifier = '225' WHERE countryCode = 'US'
UPDATE Country SET countryIdentifier = '230' WHERE countryCode = 'UY'
UPDATE Country SET countryIdentifier = '234' WHERE countryCode = 'VE'
UPDATE Country SET countryIdentifier = '12' WHERE countryCode = 'AU'
UPDATE Country SET countryIdentifier = '39' WHERE countryCode = 'CA'
UPDATE Country SET countryIdentifier = '45' WHERE countryCode = 'CN'
UPDATE Country SET countryIdentifier = '57' WHERE countryCode = 'DK'
UPDATE Country SET countryIdentifier = '13' WHERE countryCode = 'AT'
UPDATE Country SET countryIdentifier = '20' WHERE countryCode = 'BE'
UPDATE Country SET countryIdentifier = '33' WHERE countryCode = 'BG'
UPDATE Country SET countryIdentifier = '55' WHERE countryCode = 'CY'
UPDATE Country SET countryIdentifier = '36' WHERE countryCode = 'CZ'
UPDATE Country SET countryIdentifier = '67' WHERE countryCode = 'EE'
UPDATE Country SET countryIdentifier = '72' WHERE countryCode = 'FI'
UPDATE Country SET countryIdentifier = '75' WHERE countryCode = 'FR'
UPDATE Country SET countryIdentifier = '82' WHERE countryCode = 'DE'
UPDATE Country SET countryIdentifier = '86' WHERE countryCode = 'GR'
UPDATE Country SET countryIdentifier = '99' WHERE countryCode = 'HU'
UPDATE Country SET countryIdentifier = '105' WHERE countryCode = 'IE'
UPDATE Country SET countryIdentifier = '107' WHERE countryCode = 'IT'
UPDATE Country SET countryIdentifier = '119' WHERE countryCode = 'LV'
UPDATE Country SET countryIdentifier = '125' WHERE countryCode = 'LT'
UPDATE Country SET countryIdentifier = '126' WHERE countryCode = 'LU'
UPDATE Country SET countryIdentifier = '134' WHERE countryCode = 'MT'
UPDATE Country SET countryIdentifier = '152' WHERE countryCode = 'NL'
UPDATE Country SET countryIdentifier = '174' WHERE countryCode = 'PL'
UPDATE Country SET countryIdentifier = '176' WHERE countryCode = 'PT'
UPDATE Country SET countryIdentifier = '180' WHERE countryCode = 'RO'
UPDATE Country SET countryIdentifier = '184' WHERE countryCode = 'SK'
UPDATE Country SET countryIdentifier = '199' WHERE countryCode = 'SI'
UPDATE Country SET countryIdentifier = '203' WHERE countryCode = 'ES'
UPDATE Country SET countryIdentifier = '98' WHERE countryCode = 'HK'
UPDATE Country SET countryIdentifier = '110' WHERE countryCode = 'JP'
UPDATE Country SET countryIdentifier = '140' WHERE countryCode = 'MX'
UPDATE Country SET countryIdentifier = '156' WHERE countryCode = 'NZ'
UPDATE Country SET countryIdentifier = '164' WHERE countryCode = 'NO'
UPDATE Country SET countryIdentifier = '198' WHERE countryCode = 'SG'
UPDATE Country SET countryIdentifier = '209' WHERE countryCode = 'SE'
UPDATE Country SET countryIdentifier = '210' WHERE countryCode = 'CH'
UPDATE Country SET countryIdentifier = '212' WHERE countryCode = 'TW'
UPDATE Country SET countryIdentifier = '85' WHERE countryCode = 'GB'
UPDATE Country SET countryIdentifier = '229' WHERE countryCode = 'AE'
UPDATE Country SET countryIdentifier = '1' WHERE countryCode = 'AL'
UPDATE Country SET countryIdentifier = '10' WHERE countryCode = 'AM'
UPDATE Country SET countryIdentifier = '5' WHERE countryCode = 'AO'
UPDATE Country SET countryIdentifier = '14' WHERE countryCode = 'AZ'
UPDATE Country SET countryIdentifier = '34' WHERE countryCode = 'BF'
UPDATE Country SET countryIdentifier = '16' WHERE countryCode = 'BH'
UPDATE Country SET countryIdentifier = '22' WHERE countryCode = 'BJ'
UPDATE Country SET countryIdentifier = '24' WHERE countryCode = 'BT'
UPDATE Country SET countryIdentifier = '19' WHERE countryCode = 'BY'
UPDATE Country SET countryIdentifier = '27' WHERE countryCode = 'BW'
UPDATE Country SET countryIdentifier = '32' WHERE countryCode = 'BN'
UPDATE Country SET countryIdentifier = '50' WHERE countryCode = 'CG'
UPDATE Country SET countryIdentifier = '40' WHERE countryCode = 'CV'
UPDATE Country SET countryIdentifier = '2' WHERE countryCode = 'DZ'
UPDATE Country SET countryIdentifier = '63' WHERE countryCode = 'EG'
UPDATE Country SET countryIdentifier = '71' WHERE countryCode = 'FJ'
UPDATE Country SET countryIdentifier = '141' WHERE countryCode = 'FM'
UPDATE Country SET countryIdentifier = '53' WHERE countryCode = 'HR'
UPDATE Country SET countryIdentifier = '83' WHERE countryCode = 'GH'
UPDATE Country SET countryIdentifier = '80' WHERE countryCode = 'GM'
UPDATE Country SET countryIdentifier = '93' WHERE countryCode = 'GW'
UPDATE Country SET countryIdentifier = '100' WHERE countryCode = 'IS'
UPDATE Country SET countryIdentifier = '101' WHERE countryCode = 'IN'
UPDATE Country SET countryIdentifier = '102' WHERE countryCode = 'ID'
UPDATE Country SET countryIdentifier = '106' WHERE countryCode = 'IL'
UPDATE Country SET countryIdentifier = '111' WHERE countryCode = 'JO'
UPDATE Country SET countryIdentifier = '113' WHERE countryCode = 'KE'
UPDATE Country SET countryIdentifier = '117' WHERE countryCode = 'KG'
UPDATE Country SET countryIdentifier = '37' WHERE countryCode = 'KH'
UPDATE Country SET countryIdentifier = '115' WHERE countryCode = 'KR'
UPDATE Country SET countryIdentifier = '116' WHERE countryCode = 'KW'
UPDATE Country SET countryIdentifier = '112' WHERE countryCode = 'KZ'
UPDATE Country SET countryIdentifier = '118' WHERE countryCode = 'LA'
UPDATE Country SET countryIdentifier = '120' WHERE countryCode = 'LB'
UPDATE Country SET countryIdentifier = '204' WHERE countryCode = 'LK'
UPDATE Country SET countryIdentifier = '122' WHERE countryCode = 'LR'
UPDATE Country SET countryIdentifier = '142' WHERE countryCode = 'MD'
UPDATE Country SET countryIdentifier = '129' WHERE countryCode = 'MG'
UPDATE Country SET countryIdentifier = '128' WHERE countryCode = 'MK'
UPDATE Country SET countryIdentifier = '133' WHERE countryCode = 'ML'
UPDATE Country SET countryIdentifier = '144' WHERE countryCode = 'MN'
UPDATE Country SET countryIdentifier = '127' WHERE countryCode = 'MO'
UPDATE Country SET countryIdentifier = '137' WHERE countryCode = 'MR'
UPDATE Country SET countryIdentifier = '138' WHERE countryCode = 'MU'
UPDATE Country SET countryIdentifier = '130' WHERE countryCode = 'MW'
UPDATE Country SET countryIdentifier = '131' WHERE countryCode = 'MY'
UPDATE Country SET countryIdentifier = '147' WHERE countryCode = 'MZ'
UPDATE Country SET countryIdentifier = '149' WHERE countryCode = 'NA'
UPDATE Country SET countryIdentifier = '158' WHERE countryCode = 'NE'
UPDATE Country SET countryIdentifier = '159' WHERE countryCode = 'NG'
UPDATE Country SET countryIdentifier = '151' WHERE countryCode = 'NP'
UPDATE Country SET countryIdentifier = '165' WHERE countryCode = 'OM'
UPDATE Country SET countryIdentifier = '169' WHERE countryCode = 'PG'
UPDATE Country SET countryIdentifier = '172' WHERE countryCode = 'PH'
UPDATE Country SET countryIdentifier = '166' WHERE countryCode = 'PK'
UPDATE Country SET countryIdentifier = '167' WHERE countryCode = 'PW'
UPDATE Country SET countryIdentifier = '178' WHERE countryCode = 'QA'
UPDATE Country SET countryIdentifier = '181' WHERE countryCode = 'RU'
UPDATE Country SET countryIdentifier = '193' WHERE countryCode = 'SA'
UPDATE Country SET countryIdentifier = '200' WHERE countryCode = 'SB'
UPDATE Country SET countryIdentifier = '196' WHERE countryCode = 'SC'
UPDATE Country SET countryIdentifier = '197' WHERE countryCode = 'SL'
UPDATE Country SET countryIdentifier = '194' WHERE countryCode = 'SN'
UPDATE Country SET countryIdentifier = '192' WHERE countryCode = 'ST'
UPDATE Country SET countryIdentifier = '208' WHERE countryCode = 'SZ'
UPDATE Country SET countryIdentifier = '43' WHERE countryCode = 'TD'
UPDATE Country SET countryIdentifier = '215' WHERE countryCode = 'TH'
UPDATE Country SET countryIdentifier = '213' WHERE countryCode = 'TJ'
UPDATE Country SET countryIdentifier = '222' WHERE countryCode = 'TM'
UPDATE Country SET countryIdentifier = '220' WHERE countryCode = 'TN'
UPDATE Country SET countryIdentifier = '221' WHERE countryCode = 'TR'
UPDATE Country SET countryIdentifier = '214' WHERE countryCode = 'TZ'
UPDATE Country SET countryIdentifier = '228' WHERE countryCode = 'UA'
UPDATE Country SET countryIdentifier = '227' WHERE countryCode = 'UG'
UPDATE Country SET countryIdentifier = '231' WHERE countryCode = 'UZ'
UPDATE Country SET countryIdentifier = '235' WHERE countryCode = 'VN'
UPDATE Country SET countryIdentifier = '239' WHERE countryCode = 'YE'
UPDATE Country SET countryIdentifier = '202' WHERE countryCode = 'ZA'
UPDATE Country SET countryIdentifier = '243' WHERE countryCode = 'ZW'

DROP INDEX CountryRegion;

CREATE UNIQUE INDEX CountryIdentifierCodeRegionIndex ON Country ( countryIdentifier, countryCode, regionCode );

DROP TABLE DailySalesSummary;

CREATE TABLE DailySalesSummary (productId INTEGER, dateTimestamp INTEGER, saleTypeIdentifier INTEGER, units REAL, revenueInUSD REAL);

CREATE UNIQUE INDEX DailySalesSummaryProductDateSalesType ON DailySalesSummary (productId, dateTimestamp, saleTypeIdentifier);

DROP TABLE RegionSalesSummary;